# Contributing
We welcome all contributions from the community! Any contributions to `stoke` should come through valid Pull Requests 
in the public open-source repository.

## Contribution Guidelines
1. Adhere to [PEP-8](https://www.python.org/dev/peps/pep-0008/) standards.
2. Run black and isort linters before creating a PR.
3. Any changes to core functionality must pass all existing unit tests.
4. Additional functionality should have associated unit tests.
5. Provide documentation ([Numpy Docstring format](https://numpydoc.readthedocs.io/en/latest/format.html#style-guide)) whenever possible, even for simple functions or classes.